SocketObserverAdapter (Naga API)
Date: 2016-06-28

naga

## Class SocketObserverAdapter

- java.lang.Object
- - naga.SocketObserverAdapter

- All Implemented Interfaces:
    SocketObserver

      public class SocketObserverAdapter
      extends java.lang.Object
      implements SocketObserver

  Class with null-implementation of all SocketObserver callbacks.
  Author:
    Christoffer Lerno

- - ### Field Summary

    - ### Fields inherited from interface naga.SocketObserver

      `NULL`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SocketObserverAdapter()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `connectionBroken(NIOSocket nioSocket, java.lang.Exception exception)` Called by the NIOService on the NIO thread when a connection is disconnected.
    `void` | `connectionOpened(NIOSocket nioSocket)` Called by the NIOService on the NIO thread when a connection completes on a socket.
    `void` | `packetReceived(NIOSocket socket, byte[] packet)` Called by the NIOService on the NIO thread when a packet is finished reading.
    `void` | `packetSent(NIOSocket socket, java.lang.Object tag)` Called by the NIOService on the NIO thread when a packet has finished writing.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SocketObserverAdapter

          public SocketObserverAdapter()

  - ### Method Detail

    - #### connectionBroken

          public void connectionBroken(NIOSocket nioSocket,
                              java.lang.Exception exception)

      Description copied from interface: `SocketObserver`
      Called by the NIOService on the NIO thread when a connection is disconnected.

      This may be sent even if a `connectionOpened(NIOSocket)` wasn't ever called, since the connect itself may fail.

      Note: Since this is a direct callback on the NIO thread, this method will suspend IO on all other connections until the method returns. It is therefore strongly recommended that the implementation of this method returns as quickly as possible to avoid blocking IO.

      Specified by:
        `connectionBroken` in interface `SocketObserver`
      Parameters:
        `nioSocket` - the socket that was disconnected.
        `exception` - the exception that caused the connection to break, may be null.

    - #### packetReceived

          public void packetReceived(NIOSocket socket,
                            byte[] packet)

      Description copied from interface: `SocketObserver`
      Called by the NIOService on the NIO thread when a packet is finished reading. The byte array contains the packet as parsed by the current PacketReader.

      Note: Since this is a direct callback on the NIO thread, this method will suspend IO on all other connections until the method returns. It is therefore strongly recommended that the implementation of this method returns as quickly as possible to avoid blocking IO.

      Specified by:
        `packetReceived` in interface `SocketObserver`
      Parameters:
        `socket` - the socket we received a packet on.
        `packet` - the packet we received.

    - #### connectionOpened

          public void connectionOpened(NIOSocket nioSocket)

      Description copied from interface: `SocketObserver`
      Called by the NIOService on the NIO thread when a connection completes on a socket.

      Note: Since this is a direct callback on the NIO thread, this method will suspend IO on all other connections until the method returns. It is therefore strongly recommended that the implementation of this method returns as quickly as possible to avoid blocking IO.

      Specified by:
        `connectionOpened` in interface `SocketObserver`
      Parameters:
        `nioSocket` - the socket that completed its connect.

    - #### packetSent

          public void packetSent(NIOSocket socket,
                        java.lang.Object tag)

      Description copied from interface: `SocketObserver`
      Called by the NIOService on the NIO thread when a packet has finished writing.

      Note: Since this is a direct callback on the NIO thread, this method will suspend IO on all other connections until the method returns. It is therefore strongly recommended that the implementation of this method returns as quickly as possible to avoid blocking IO.

      Specified by:
        `packetSent` in interface `SocketObserver`
      Parameters:
        `socket` - the socket we sent the packet on.
        `tag` - the (optional) tag associated with the packet.